<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題6.9 - ロジスティック写像のリアプノフ指数 &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題6.12 - エノン写像" href="../6-12_henon/6-12.html" />
    <link rel="prev" title="問題6.8 - 他の1次元写像" href="../6-8_other_example/6-8.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../6-12_henon/6-12.html" title="問題6.12 - エノン写像"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../6-8_other_example/6-8.html" title="問題6.8 - 他の1次元写像"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題6.9 - ロジスティック写像のリアプノフ指数</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題6.9 - ロジスティック写像のリアプノフ指数</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>系がカオス的かどうか判断する指標として、カオスの重要な性質である初期条件への敏感さを考えることができる。一般に、同一の力学系で異なる初期条件から開始するなら、軌跡差は<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>の関数として変化するであろう。<a class="reference internal" href="#fig-6-9-f1"><em>図1</em></a>にロジスティック写像における差<img class="math" src="../_images/math/64a4ab345a1c7262f040d4d92118043a758a2166.png" alt="|\Delta x_{n}|"/>と<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>の関係を図示してある。大まかに言って、<img class="math" src="../_images/math/acdb101f7aae8f50efebe5beaaa7ed9f81c3f2a7.png" alt="\ln |\Delta x_{n}|"/>は<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>の線形な増加関数であり、このことは、系がカオス的なら軌跡間の距離は指数関数的に大きくなることを意味する。このような発散の特徴は以下に示すリアプノフ(Lyapunov)指数<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>によって記述され、関係式</p>
<div class="math" id="equation-e1">
<p><span class="eqno">(1)</span><img src="../_images/math/a55d2bab332e8540d199a58a276ea15fb8f660b5.png" alt="|\Delta x_{n}| = |\Delta x_{0}|e^{\lambda n}"/></p>
</div><p>で定義される。ここで<img class="math" src="../_images/math/1706c7bdf1d5bf0cc2cbcc59018b58b7b4ac4bf8.png" alt="\Delta x_{n}"/>は時刻<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>における軌跡間の差である。もしリアプノフ指数<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>が正なら、近接した軌跡間の距離も指数関数的に広がり、系はカオス的であると言える。本シミュレーションではロジスティック写像について、このリアプノフ指数を求めることを目的とする。</p>
<p>リアプノフ指数を測定する素朴な方法は、わずかに異なる初期条件のもとで同じ力学系を時間発展させ、<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>の関数として実際に軌跡の差を測定することである。これらの軌跡が互いに離れていく速さは<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>の選び方によるので、多くの<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>の値について離れていく速さを計算する必要がある。<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>の各値に対して距離を式<a href="#equation-e1">(1)</a>に合わせ、それから<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の平均値を求めなければならないので、この方法には手間がかかる。</p>
<p>素朴な方法のさらに重大な限界は、軌跡が0から1までの区間に制限されているような場合に、<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>が十分に大きくなると距離<img class="math" src="../_images/math/64a4ab345a1c7262f040d4d92118043a758a2166.png" alt="|\Delta x_{n}|"/>の値はある一定の大きさ以上には大きくなれなくなってしまうことである。しかし、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の計算を可能な限り正確にするために、可能な限り多くの反復により平均を求めたい。これを実現する方法を説明するために、まず式<a href="#equation-e1">(1)</a>を変形して、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を</p>
<div class="math">
<p><img src="../_images/math/b67a5c58de84f071cde405caa36de8b3fdfbf0ca.png" alt="\lambda=\frac{1}{n}\ln \left| \frac{\Delta x_{n}}{\Delta x_{0}} \right|"/></p>
</div><p>と書く。過渡的な振る舞いが終わった後の全軌跡のデータを使いたいので、</p>
<div class="math">
<p><img src="../_images/math/8b79a833974e8621e9d40a2af9fb8b213bcc3a55.png" alt="\frac{\Delta x_{n}}{\Delta x_{0}}=\frac{\Delta x_{1}}{\Delta x_{0}}\frac{\Delta x_{2}}{\Delta x_{1}} \cdots \frac{\Delta x_{n}}{\Delta x_{n-1}}"/></p>
</div><p>という関係に着目すると、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を</p>
<div class="math" id="equation-e2">
<p><span class="eqno">(2)</span><img src="../_images/math/ecf53318c01c91884b5a504ab351af98c15e7910.png" alt="\lambda = \frac{1}{n}\sum_{i=0}^{n-1}\ln \left| \frac{\Delta x_{i+1}}{\Delta x_{i}} \right|"/></p>
</div><p>と表すことができる。式<a href="#equation-e2">(2)</a>は、任意の<img class="math" src="../_images/math/a581f053bbfa5115f42c13094857cdd12a37ec49.png" alt="i"/>について<img class="math" src="../_images/math/c223a5391d7bfd7e7c68274c104fc7418944376e.png" alt="x_{i}"/>を初期条件として考えることができるということを意味している。</p>
<div class="align-center figure" id="fig-6-9-f1">
<a class="reference internal image-reference" href="../_images/figure_test.pdf"><img alt="r = 0.91 のときのロジスティック写像の x0 = 0.5 と x0 = 0.5001 で開始した軌跡間の差 Δx_n の変化" src="../_images/figure_test.pdf" style="width: 12.5cm;" /></a>
</div>
<p>式<a href="#equation-e2">(2)</a>から、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を計算する問題は比<img class="math" src="../_images/math/bacf12f3f21c8783082be9f2437b73363edbde52.png" alt="\Delta x_{i+1} / \Delta x_{i}"/>を求めることに帰着することが分かる。2つの軌跡間の最初の差を可能な限り小さくしたいので、極限<img class="math" src="../_images/math/c77ee45482e8ce9564ecc9cfb30d8f92fa29bfd1.png" alt="\Delta x_{i} \rightarrow 0"/>を考えて、微分<img class="math" src="../_images/math/e3686503a088b901268b3104c313a215b65a0f11.png" alt="dx_{i}"/>を計算すればよい。例としてロジスティック写像</p>
<div class="math">
<p><img src="../_images/math/917c3910e384838bd0738f658f7a67b70f2a9e1f.png" alt="f(x_{i})=4rx_{i}(1-x_{i})"/></p>
</div><p>の微分は</p>
<div class="math" id="equation-e3">
<p><span class="eqno">(3)</span><img src="../_images/math/90bcea36a3a1acc7304051cda8efd70806356ce2.png" alt="\frac{dx_{i+1}}{dx_{i}}=f'(x_{i})= 4r(1-2x_{i})"/></p>
</div><p>であるが、<a class="reference internal" href="../6-2_bifurcate/6-2.html#label"><em>問題6.2</em></a>で行ったようにロジスティック写像の反復を行い、その反復ごとに関係<a href="#equation-e3">(3)</a>と<img class="math" src="../_images/math/c223a5391d7bfd7e7c68274c104fc7418944376e.png" alt="x_{i}"/>の値を使えば、<img class="math" src="../_images/math/a8756d0761c3b4c3a4ec73868b8034fdb255a231.png" alt="dx_{i+1}/dx_{i}"/>を計算することができる。したがってリアプノフ指数は</p>
<div class="math" id="equation-e4">
<p><span class="eqno">(4)</span><img src="../_images/math/d9f8c3e975ae3cb7bdfd4c23f9f520dd5a79decb.png" alt="\lambda = \lim_{n \rightarrow \infty} \frac{1}{n} \sum_{i=0}^{n-1} \ln | f'(x_{i}) |"/></p>
</div><p>で与えられることとなる。ここで、式<a href="#equation-e4">(4)</a>の和は過渡的な振る舞いが終わってからとり始める。<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>を十分に大きく選ぶことを意識するために、式<a href="#equation-e4">(4)</a>には<img class="math" src="../_images/math/940cc04250d65618093ae95efc888b0d7f0b8059.png" alt="n \rightarrow \infty"/>の極限を明示的に書いた。この方法はアトラクタ上の点に正しく重みを付けていて、軌跡がアトラクタのある特定の領域を多くは訪れない場合に、その領域は式<a href="#equation-e4">(4)</a>の和にあまり寄与しない。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションで作成したプログラムを以下に示す。</p>
<ul class="simple">
<li>パラメータの設定ダイアログ( <a class="reference download internal" href="../_downloads/SetParameter5.py"><tt class="xref download docutils literal"><span class="pre">SetParameter.py</span></tt></a> )</li>
</ul>
<p>以前作成したプログラムをモジュールとして用いる。self.show_setting_window()によって、その引数として与えられたパラメータのリストの数に応じてパラメータの入力エントリが生成され、self.entry[i].get()でi番目の要素の取得ができる。OKボタンを押した時の挙動は、commandに関数を指定することで決めることができる。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, Mqy 2014.</span>
<span class="c">#</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">SetParameter</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_setting_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parameters</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a parameter setting window.</span>
<span class="sd">                </span>
<span class="sd">        parameters: A list of dictionaries {&#39;parameter name&#39;:default_value}</span>
<span class="sd">        commands: A dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Control Widget&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">parameter</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">parameters</span><span class="p">):</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s">&#39; = &#39;</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">sticky</span><span class="o">=</span><span class="n">E</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Entry</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">10</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">END</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">focus_set</span><span class="p">()</span>
       
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="n">commands</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">button</span> <span class="o">=</span> <span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="p">)</span>
            <span class="n">button</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;left&#39;</span><span class="p">,</span> <span class="n">fill</span><span class="o">=</span><span class="s">&#39;x&#39;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>素朴な方法によりリアプノフ指数を計算するプログラム</li>
</ul>
<ul class="simple">
<li><a class="reference download internal" href="../_downloads/6-9_lyapunov-a0.py"><tt class="xref download docutils literal"><span class="pre">6-9_lyapunov-a0.py</span></tt></a></li>
</ul>
<p><img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>を<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>に対してプロットするプログラム。このプログラムを実行すると、まず、先のSetParameterを利用して、各パラメータを代入し、その値を用いてロジスティック写像の時間発展を計算する。その際同時に<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>の計算も行い、配列に格納する。最後に横軸<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>、縦軸<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>としてグラフを描画し、表示させている。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.9 リアプノフ指数</span>
<span class="c"># -a0 </span>
<span class="c"># \ln | \Delta x_{n} / \Delta x_{0} |のグラフの描画</span>

<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">array</span> <span class="kn">as</span> <span class="nn">array</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span> <span class="c"># 同じディレクトリにSetParameter.pyを置く</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="k">global</span> <span class="n">r</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">nmax</span>
    <span class="n">r</span>        <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">x0</span>       <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">delta_x0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nmax</span>     <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">mapping</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">nmax</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
    <span class="k">return</span> <span class="mf">4.0</span><span class="o">*</span><span class="n">r</span><span class="o">*</span><span class="n">x_i</span><span class="o">*</span><span class="p">(</span><span class="mi">1</span><span class="o">-</span><span class="n">x_i</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">mapping</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">nmax</span><span class="p">):</span> <span class="c"># グラフの描画</span>
    <span class="n">x1</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">x1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span>
    <span class="n">x2</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">x2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x0</span><span class="o">+</span><span class="n">delta_x0</span><span class="p">)</span>
    <span class="n">lya</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">count</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nmax</span><span class="p">):</span>
        <span class="n">x1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">func</span><span class="p">(</span><span class="n">x1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">r</span><span class="p">))</span>
        <span class="n">x2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">func</span><span class="p">(</span><span class="n">x2</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">r</span><span class="p">))</span>
        <span class="n">l</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="nb">abs</span><span class="p">((</span><span class="n">x2</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">-</span><span class="n">x1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">/</span><span class="n">delta_x0</span><span class="p">))</span>
        <span class="n">lya</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">l</span><span class="p">)</span>
    <span class="n">n</span><span class="o">=</span><span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">nmax</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">n</span><span class="p">,</span> <span class="n">lya</span><span class="p">,</span> 
            <span class="n">label</span> <span class="o">=</span>  <span class="s">r&#39;$r=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">r</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span> 
            <span class="o">+</span> <span class="s">r&#39;$x_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
            <span class="o">+</span> <span class="s">r&#39;$\Delta x_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">delta_x0</span><span class="p">)</span>
            <span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">nmax</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">lya</span><span class="p">)</span><span class="o">-</span><span class="mf">0.3</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">lya</span><span class="p">)</span><span class="o">+</span><span class="mf">0.3</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$n$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$\ln | \Delta x_{n} / \Delta x_{0}| $&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Graph of &#39;r&#39;$\ln | \Delta x_{n} / \Delta x_{0} |$&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;r&#39;</span><span class="p">:</span><span class="mf">0.91</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.5</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;delta_x0&#39;</span><span class="p">:</span><span class="mf">0.000001</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nmax&#39;</span><span class="p">:</span><span class="mi">200</span><span class="p">}]</span>
    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
    
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li><a class="reference download internal" href="../_downloads/6-9_lyapunov-a.py"><tt class="xref download docutils literal"><span class="pre">6-9_lyapunov-a.py</span></tt></a></li>
</ul>
<p>このプログラムを実行すると、まず設定値<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>、<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>、dxの設定ダイアログが表示され、値を入れてOKボタンを押すと、<img class="math" src="../_images/math/d0e4cc4cf39d558e012a5b82fdc773b070cc59a6.png" alt="0 &lt; x_{0} &lt; 1"/>の範囲でdxの間隔でリアプノフ指数が計算され、横軸<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>、縦軸<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>のグラフと、その平均値が表示される。プログラムの中身については、まず、与えられたdx、<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>を元にCalculateLambda内の関数set_parameterによって初期値<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>と<img class="math" src="../_images/math/8f08cb5971141ec988d87d57cd9d48460ff972e7.png" alt="x_{0}+\Delta x_{0}"/>の配列が作成される。次にその各値についてlambda_for_x0が適用されて<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>が計算され、インスタンス配列self.lyapunovsに格納される。最後にplot_x0_lambdaとplot_average_lambdaがその値を用いてグラフを描画するという仕組みになっている。数値計算の肝となるCalculateLambdaの部分については次項で説明する。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.9 リアプノフ指数</span>
<span class="c"># -a 素朴な方法でロジスティック写像のリアプノフ指数を求める</span>
<span class="c"># 例:</span>
<span class="c">#   r        = 0.91    : control parameter</span>
<span class="c">#   delta_x0 = 0.00005 : width of initial values</span>
<span class="c">#   dx       = 0.001   : step size of x0</span>


<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span> <span class="c"># 同じディレクトリにSetParameter.pyを置く</span>
<span class="kn">import</span> <span class="nn">CalculateLambda</span> <span class="kn">as</span> <span class="nn">cl</span> <span class="c"># 同じディレクトリにCalculateLambda.pyを置く</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="k">global</span> <span class="n">r</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">dx</span>
    <span class="n">r</span>        <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">delta_x0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">dx</span>       <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    
<span class="k">def</span> <span class="nf">plot_x0_lambda</span><span class="p">(</span><span class="n">x0</span><span class="p">,</span> <span class="n">lyapunovs</span><span class="p">):</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">x0</span><span class="p">,</span> <span class="n">lyapunovs</span><span class="p">,</span>
            <span class="n">label</span> <span class="o">=</span> <span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">+</span> <span class="s">r&#39;$r=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">r</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span>
            <span class="o">+</span><span class="s">&#39;$\Delta x_{0}\ (:\mathrm{width\ of\ initial\ values})=$&#39;</span> 
            <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">delta_x0</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span>
            <span class="o">+</span> <span class="s">&#39;$dx\ (:\mathrm{step\ size\ of\ }x_{0})=$&#39;</span> 
            <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">dx</span><span class="p">)</span>
            <span class="p">)</span>

<span class="k">def</span> <span class="nf">plot_average_lambda</span><span class="p">(</span><span class="n">x0</span><span class="p">,</span> <span class="n">lyapunovs</span><span class="p">):</span>
    <span class="n">ave_lambda</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">lyapunovs</span><span class="p">)</span><span class="o">/</span><span class="nb">len</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">],</span> <span class="p">[</span><span class="n">ave_lambda</span><span class="p">]</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span>
            <span class="n">label</span> <span class="o">=</span> <span class="s">r&#39;$\mathrm{average\ of\ } \lambda=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">ave_lambda</span><span class="p">)</span>
            <span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">lyapunovs</span><span class="p">)</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">lyapunovs</span><span class="p">)</span><span class="o">+</span><span class="mf">0.1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$x_{0}$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$\lambda$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Lyapunov index&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;r&#39;</span><span class="p">:</span><span class="mf">0.91</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;delta_x0&#39;</span><span class="p">:</span><span class="mf">0.000001</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;dx&#39;</span><span class="p">:</span><span class="mf">0.01</span><span class="p">}]</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
    
    <span class="n">calculate</span> <span class="o">=</span> <span class="n">cl</span><span class="o">.</span><span class="n">CalculateLambda</span><span class="p">()</span>
    <span class="n">calculate</span><span class="o">.</span><span class="n">set_parameter</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">dx</span><span class="p">)</span>
    <span class="n">calculate</span><span class="o">.</span><span class="n">prepare_x0_and_lambda</span><span class="p">()</span>
    
    <span class="n">plot_x0_lambda</span><span class="p">(</span><span class="n">calculate</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="n">calculate</span><span class="o">.</span><span class="n">lyapunovs</span><span class="p">)</span>
    <span class="n">plot_average_lambda</span><span class="p">(</span><span class="n">calculate</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="n">calculate</span><span class="o">.</span><span class="n">lyapunovs</span><span class="p">)</span>
    
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
    
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li><a class="reference download internal" href="../_downloads/CalculateLambda.py"><tt class="xref download docutils literal"><span class="pre">CalculateLambda.py</span></tt></a></li>
</ul>
<p>このプログラムは6-9_lyapunov-a.pyから呼び出されるモジュールとして機能しており、これに具体的な値を代入して関数の部分それぞれを独立に実行させることができる。lambda_for_x0の中で実際に<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>が計算されおり、いくつかの試行により先に与えたnplotまでのnについて、最小二乗法で直線へのフィッティングを行い、その傾きを戻り値となるようにしてある。このプログラムでのnplotの選び方は非常に恣意的で、しかもこの値によって<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値は大きく変わりうる。本来ならばプログラム中で有効な範囲を判断してその範囲でフィッティングを行うべきであるが、その過程を自動化する良い解決策が見つからなかった。あるいは<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>の値ごとに毎回グラフを表示して人の目で適用範囲を決めていくこともできるが、それでは良いプログラムとは言えない。この点において改良の必要がある。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>

<span class="kn">import</span> <span class="nn">array</span> <span class="kn">as</span> <span class="nn">array</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">scipy.optimize</span> <span class="kn">as</span> <span class="nn">optimize</span>

<span class="k">class</span> <span class="nc">CalculateLambda</span><span class="p">():</span>
    
    <span class="k">def</span> <span class="nf">set_parameter</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">delta_x0</span><span class="p">,</span> <span class="n">dx</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">r</span> <span class="o">=</span> <span class="n">r</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">delta_x0</span> <span class="o">=</span> <span class="n">delta_x0</span>
        <span class="n">dx</span> <span class="o">=</span> <span class="n">dx</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">n</span> <span class="o">=</span> <span class="nb">int</span><span class="p">((</span><span class="mf">1.0</span><span class="o">-</span><span class="bp">self</span><span class="o">.</span><span class="n">delta_x0</span><span class="p">)</span><span class="o">/</span><span class="n">dx</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([(</span><span class="n">n</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span><span class="o">*</span><span class="n">dx</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">n</span><span class="p">)])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x0_plus_delta_x0</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="o">+</span><span class="bp">self</span><span class="o">.</span><span class="n">delta_x0</span>
        <span class="k">return</span> <span class="bp">None</span>
        
    <span class="k">def</span> <span class="nf">prepare_x0_and_lambda</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">lyapunovs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">lambda_for_x0</span><span class="p">(</span><span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">)</span> <span class="k">for</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span> 
                                 <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">x0_plus_delta_x0</span><span class="p">)</span>
                                 <span class="p">])</span>
    
    <span class="k">def</span> <span class="nf">lambda_for_x0</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">x2</span><span class="p">):</span>
        <span class="n">r</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">r</span>               <span class="c"># - localize</span>
        <span class="n">delta_x0</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">delta_x0</span> <span class="c"># -</span>
        <span class="n">nplot</span> <span class="o">=</span> <span class="mi">50</span>  <span class="c"># Note: This value is determined by some trials.</span>
                    <span class="c">#       It affecs directory the value of lyapunov index.</span>
        
        <span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">):</span>
            <span class="k">return</span> <span class="mf">4.0</span><span class="o">*</span><span class="n">r</span><span class="o">*</span><span class="n">x_i</span><span class="o">*</span><span class="p">(</span><span class="mf">1.0</span><span class="o">-</span><span class="n">x_i</span><span class="p">)</span>
        
        <span class="n">ary1</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
        <span class="n">ary1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x1</span><span class="p">)</span>
        <span class="n">ary2</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
        <span class="n">ary2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x2</span><span class="p">)</span>
        <span class="n">lya</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
        <span class="n">lya</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="nb">abs</span><span class="p">((</span><span class="n">ary2</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">-</span><span class="n">ary1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">/</span><span class="n">delta_x0</span><span class="p">)))</span>
        <span class="k">for</span> <span class="n">count</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nplot</span><span class="o">-</span><span class="mi">1</span><span class="p">):</span>
            <span class="n">ary1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">func</span><span class="p">(</span><span class="n">ary1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]))</span>
            <span class="n">ary2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">func</span><span class="p">(</span><span class="n">ary2</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]))</span>
            <span class="n">l</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="nb">abs</span><span class="p">((</span><span class="n">ary2</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">-</span><span class="n">ary1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">/</span><span class="n">delta_x0</span><span class="p">))</span>
            <span class="n">lya</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">l</span><span class="p">)</span>
        
        <span class="c"># -- optimize -- </span>
    
        <span class="k">def</span> <span class="nf">fit_func</span><span class="p">(</span><span class="n">parameter0</span><span class="p">,</span> <span class="n">n</span><span class="p">,</span> <span class="n">lya</span><span class="p">):</span>
            <span class="n">a</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">b</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">residual</span> <span class="o">=</span> <span class="n">lya</span> <span class="o">-</span> <span class="p">(</span><span class="n">a</span><span class="o">*</span><span class="n">n</span> <span class="o">+</span> <span class="n">b</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">residual</span>
        
        <span class="n">parameter0</span> <span class="o">=</span> <span class="p">[</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">]</span> <span class="c"># initial value of parameters a, b (ln||=a*n+b)</span>
        <span class="n">n</span> <span class="o">=</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="n">nplot</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">optimize</span><span class="o">.</span><span class="n">leastsq</span><span class="p">(</span><span class="n">fit_func</span><span class="p">,</span> <span class="n">parameter0</span><span class="p">,</span> 
                                  <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">n</span><span class="p">),</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">lya</span><span class="p">))</span>
                                 <span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>アルゴリズムを用いてリアプノフ指数を計算するプログラム( <a class="reference download internal" href="../_downloads/6-9_lyapunov-b.py"><tt class="xref download docutils literal"><span class="pre">6-9_lyapunov-b.py</span></tt></a> )</li>
</ul>
<p>前述したアルゴリズムに基づいて、リアプノフ指数を求めるプログラムを以下に示す。このプログラムでは、まずdr刻みの<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の配列を作成し、そのそれぞれの<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>について関数get_lambda_rを計算する。関数get_lambda_rは、時間発展で変化する<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>を計算し、ntransient回以降のデータのみ切り出し、そのそれぞれの<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>についての微分係数を計算して、最後にその平均を返している。最終的に、このようにして得られた<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>と<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の組を使ってグラフを描画する。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.9 リアプノフ指数</span>
<span class="c"># -b 教科書で示されたアルゴリズムを用いて</span>
<span class="c"># ロジスティック写像のリアプノフ指数を求める。</span>
<span class="c">#</span>

<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">array</span> <span class="kn">as</span> <span class="nn">array</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>

<span class="c"># --- set parameters ---</span>

<span class="n">r0</span> <span class="o">=</span> <span class="mf">0.76</span>
<span class="n">rmax</span> <span class="o">=</span> <span class="mf">1.0</span>
<span class="n">dr</span> <span class="o">=</span> <span class="mf">0.01</span>
<span class="n">ntransient</span> <span class="o">=</span> <span class="mi">1000</span>
<span class="n">n_calc</span> <span class="o">=</span> <span class="mi">100000</span>
<span class="n">x0</span> <span class="o">=</span> <span class="mf">0.5</span>

<span class="n">nmax</span> <span class="o">=</span> <span class="n">ntransient</span> <span class="o">+</span> <span class="n">n_calc</span>

<span class="k">def</span> <span class="nf">lambda_for_r</span><span class="p">():</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span> <span class="o">%</span> <span class="n">dr</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
        <span class="n">count</span> <span class="o">=</span> <span class="nb">int</span><span class="p">((</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span><span class="o">/</span><span class="n">dr</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">count</span> <span class="o">=</span> <span class="nb">int</span><span class="p">((</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span><span class="o">/</span><span class="n">dr</span><span class="p">)</span>
    <span class="n">r</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;f&#39;</span><span class="p">)</span>
    <span class="n">_lambda</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;f&#39;</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">count</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">_r</span> <span class="o">=</span> <span class="n">r0</span><span class="o">+</span><span class="n">dr</span><span class="o">*</span><span class="n">n</span>
        <span class="n">r</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">_r</span><span class="p">)</span>
        <span class="n">_lambda</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">get_lambda_r</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">_r</span><span class="p">))</span>
    <span class="n">r</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">rmax</span><span class="p">)</span>
    <span class="n">_lambda</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">get_lambda_r</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">rmax</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">r</span><span class="p">,</span> <span class="n">_lambda</span>

<span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
    <span class="k">return</span> <span class="mf">4.0</span><span class="o">*</span><span class="n">r</span><span class="o">*</span><span class="n">x_i</span><span class="o">*</span><span class="p">(</span><span class="mf">1.0</span><span class="o">-</span><span class="n">x_i</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">get_lambda_r</span><span class="p">(</span><span class="n">function</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
    <span class="n">x</span> <span class="o">=</span> <span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">nmax</span><span class="p">):</span>
        <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">function</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">r</span><span class="p">))</span>

    <span class="k">def</span> <span class="nf">operate</span><span class="p">(</span><span class="n">cx</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="nb">abs</span><span class="p">(</span><span class="mf">4.0</span><span class="o">*</span><span class="n">r</span><span class="o">*</span><span class="p">(</span><span class="mf">1.0</span><span class="o">-</span><span class="mf">2.0</span><span class="o">*</span><span class="n">cx</span><span class="p">)))</span>
    
    <span class="n">cutted_x</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">ntransient</span><span class="p">:</span><span class="n">nmax</span><span class="p">]</span>
    <span class="n">edited_x</span> <span class="o">=</span> <span class="nb">map</span><span class="p">(</span><span class="n">operate</span><span class="p">,</span> <span class="n">cutted_x</span><span class="p">)</span>
    <span class="n">lambda_r</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">edited_x</span><span class="p">)</span><span class="o">/</span><span class="nb">len</span><span class="p">(</span><span class="n">edited_x</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">lambda_r</span>

<span class="n">r_and_lambda</span> <span class="o">=</span> <span class="n">lambda_for_r</span><span class="p">()</span>
<span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="o">-</span><span class="mf">2.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">r_and_lambda</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">r_and_lambda</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;b&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;.&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">([</span><span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">],</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="s">&#39;r--&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$r$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$\lambda$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Lyapunov index&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li>ロジスティック写像のリアプノフ指数<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を素朴な方法で計算せよ。<img class="math" src="../_images/math/ef2ca0c8b3f4d99d0306c96356482ce21147dc65.png" alt="r=0.91"/>、<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>、<img class="math" src="../_images/math/b9f734460fefe27c006947f126c0746406f9b49a.png" alt="\Delta x_{0}=10^{-6}"/>とし、<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>を<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>に対してプロットせよ。<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>が大きいときには<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>はどうなるか。<img class="math" src="../_images/math/ef2ca0c8b3f4d99d0306c96356482ce21147dc65.png" alt="r=0.91"/>、<img class="math" src="../_images/math/d06fad126edf46809fa7c864bef9d20f1f3d7918.png" alt="r=0.97"/>、<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>について<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を求めよ。<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の各値に対する<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値は<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>や<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>の選び方に強く依存するか。</li>
</ol>
<p>はじめに、<img class="math" src="../_images/math/ef2ca0c8b3f4d99d0306c96356482ce21147dc65.png" alt="r=0.91"/>、<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>、<img class="math" src="../_images/math/b9f734460fefe27c006947f126c0746406f9b49a.png" alt="\Delta x_{0}=10^{-6}"/>として<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>を<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>に対してプロットしたものを<a class="reference internal" href="#fig-6-9-f2"><em>図2</em></a>に示す。このグラフから、<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>は<img class="math" src="../_images/math/8c2db95c9cf19667a0801c55e75d3bfa17c7aeb8.png" alt="1 \le n \le 100"/>の領域では、<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>が大きくなるにつれて大まかに見て線形に増加しており、それ以後<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>が大きいときには<img class="math" src="../_images/math/8f881d76b2c04648ac196f940b52bdd97c26c43d.png" alt="\ln |\Delta x_{n} / \Delta x_{0}|"/>はおよそ11の周囲で振動していることが分かる。これは、素朴な方法の欠点として前述したとおり、<img class="math" src="../_images/math/8f7af1c5494a324b7039d7045e71f65fecfdbc1b.png" alt="x_{n}"/>の値に制限があるような今回の場合においては、仮に<img class="math" src="../_images/math/1706c7bdf1d5bf0cc2cbcc59018b58b7b4ac4bf8.png" alt="\Delta x_{n}"/>が1となり得たとして、</p>
<div class="math">
<p><img src="../_images/math/618dd227607d6668863e9015b58e69230264c4a0.png" alt="\max \left( \ln \left| \frac{\Delta x_{n}}{\Delta x_{0}} \right| \right) = \ln \left| \frac{1}{\Delta x_{0}} \right|"/></p>
</div><p>であり、今<img class="math" src="../_images/math/b9f734460fefe27c006947f126c0746406f9b49a.png" alt="\Delta x_{0}=10^{-6}"/>としていたため、<img class="math" src="../_images/math/2983652e9817b17c534be9d0302a9b0834c8974a.png" alt="\max ( \ln | \Delta x_{n} / \Delta x_{0} | ) = 6 \ln 10 \simeq 13.8"/>となる。ここで得られたグラフと再び比較すると、<img class="math" src="../_images/math/8daf1e1518d939d4fb598b9e2d8f9f3fb0e9f97b.png" alt="\ln | \Delta x_{n} / \Delta x_{0} |"/>の極大値は12程度であると分かるので、したがって<img class="math" src="../_images/math/1742bdba3aee65f9c2df4f7724288263b18a2300.png" alt="\max ( \Delta x_{n} )"/>は実際には<img class="math" src="../_images/math/a0792ec2574980e8e8aaa150a20a18cf0d91cdbf.png" alt="10^{-1}"/>程度であることも推測される。</p>
<div class="align-center figure" id="fig-6-9-f2">
<a class="reference internal image-reference" href="../_images/figure_16.png"><img alt="ln|Δx_n / Δx_0| のグラフ" src="../_images/figure_16.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/06059cbfd71f473081081c78528a927c563dc3f1.png" alt="\ln | \Delta x_{n} / \Delta x_{0}|"/>のグラフ</p>
</div>
<p>次に、<img class="math" src="../_images/math/ef2ca0c8b3f4d99d0306c96356482ce21147dc65.png" alt="r=0.91"/>、<img class="math" src="../_images/math/d06fad126edf46809fa7c864bef9d20f1f3d7918.png" alt="r=0.97"/>、<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>について<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を求めることにする。基本的な考え方としては、<a class="reference internal" href="#fig-6-9-f2"><em>図2</em></a>で得られたようなグラフを、さまざまな<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>について試し、グラフで<img class="math" src="../_images/math/8daf1e1518d939d4fb598b9e2d8f9f3fb0e9f97b.png" alt="\ln | \Delta x_{n} / \Delta x_{0} |"/>が線形に増加している部分の傾きをその<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>での<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>と見ればよい。<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値が<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>に依存するかどうか確かめるため、また平均値をとって<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の精度を高めるために、間隔<img class="math" src="../_images/math/908f0ff0f03195b422218fc86681789918a2f136.png" alt="dx=0.01"/>おきの<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>についてそれぞれ<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を求め、横軸を<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>、縦軸を<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>としたグラフを描いてみる。<img class="math" src="../_images/math/ef2ca0c8b3f4d99d0306c96356482ce21147dc65.png" alt="r=0.91"/>、<img class="math" src="../_images/math/b9f734460fefe27c006947f126c0746406f9b49a.png" alt="\Delta x_{0}=10^{-6}"/>として、傾きをとる区間をn=50までとしたものを<a class="reference internal" href="#fig-6-9-f3"><em>図3</em></a>に示す。また<a class="reference internal" href="#fig-6-9-f4"><em>図4</em></a>には<img class="math" src="../_images/math/d06fad126edf46809fa7c864bef9d20f1f3d7918.png" alt="r=0.97"/>でそれ以外の条件を同じにしたものを、<a class="reference internal" href="#fig-6-9-f5"><em>図5</em></a>に<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>でそれ以外の数値を同じにしたものを示した。これらのグラフからは、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値は<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>に依存して変動しているが、その取る値は平均値の周辺にまとまって分布しており、なにか決まった関係性があるわけではないということが推測される。しかし、<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>での<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>は大きく突出していることに注目する必要があるだろう。</p>
<div class="align-center figure" id="fig-6-9-f3">
<a class="reference internal image-reference" href="../_images/figure_61.png"><img alt="r = 0.91 、Δx0 = 10^{-6} としたときの n-λ グラフ" src="../_images/figure_61.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/cc141374b8cb07efc513dd52bc27eb23377bd7e6.png" alt="r = 0.91"/>、<img class="math" src="../_images/math/3cbde63fe9cac6091b6294b92bf529f2260d3aa8.png" alt="\Delta x_{0} = 10^{-6}"/> としたときの<img class="math" src="../_images/math/80a283abd8b8d0e98ad735f71a980451c5f1b6d6.png" alt="n - \lambda"/>グラフ</p>
</div>
<div class="align-center figure" id="fig-6-9-f4">
<a class="reference internal image-reference" href="../_images/figure_71.png"><img alt="r = 0.97 、Δx0 = 10^{-6} としたときの n-λ グラフ" src="../_images/figure_71.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/415352a3e94b7cf48a49fdef84705c7d310199c8.png" alt="r = 0.97"/>、<img class="math" src="../_images/math/3cbde63fe9cac6091b6294b92bf529f2260d3aa8.png" alt="\Delta x_{0} = 10^{-6}"/> としたときの<img class="math" src="../_images/math/80a283abd8b8d0e98ad735f71a980451c5f1b6d6.png" alt="n - \lambda"/>グラフ</p>
</div>
<div class="align-center figure" id="fig-6-9-f5">
<a class="reference internal image-reference" href="../_images/figure_81.png"><img alt="r = 1.0 、Δx0 = 10^{-6} としたときの n-λ グラフ" src="../_images/figure_81.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/11663acead2adb9653bec37aea951f283664aef9.png" alt="r = 1.0"/>、<img class="math" src="../_images/math/3cbde63fe9cac6091b6294b92bf529f2260d3aa8.png" alt="\Delta x_{0} = 10^{-6}"/> としたときの<img class="math" src="../_images/math/80a283abd8b8d0e98ad735f71a980451c5f1b6d6.png" alt="n - \lambda"/>グラフ</p>
</div>
<p>では次に、<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>の大きさに関する依存性はどうであろうか。<img class="math" src="../_images/math/d06fad126edf46809fa7c864bef9d20f1f3d7918.png" alt="r=0.97"/>で固定し、<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>を<img class="math" src="../_images/math/7be930736ec2e547a7c87b0d22acf1e99466fd86.png" alt="\Delta x_{0} = 10^{-4}"/>、<img class="math" src="../_images/math/269435a5d5273bd7237630944032e7b2e8f9ac59.png" alt="10^{-6}"/>、<img class="math" src="../_images/math/21657abf2dea8e36fed8ad9de97c6a7d36bb6953.png" alt="10^{-8}"/>とした場合のグラフを<a class="reference internal" href="#fig-6-9-f6"><em>図6</em></a>、<a class="reference internal" href="#fig-6-9-f7"><em>図7</em></a>、<a class="reference internal" href="#fig-6-9-f8"><em>図8</em></a>に示す。このグラフからもわかるように、<img class="math" src="../_images/math/4505f4a09bdb322b02fb68405eda3f6ed367e3a4.png" alt="\Delta x_{0}"/>の大きさは、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値に影響を与えていることがわかる。しかし、これはnplotの選び方が一意でないことと、nplotの大きさが小さいために過渡現象の大きな振動の効果が影響してしまうこととに起因する。これらの考察からも、素朴な方法でリアプノフ指数を求めることの困難さが理解できる。</p>
<div class="align-center figure" id="fig-6-9-f6">
<a class="reference internal image-reference" href="../_images/figure_91.png"><img alt="r = 0.97 、Δx0 = 10^{-4} 、nplot=30としたときの x0-λ グラフ" src="../_images/figure_91.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/415352a3e94b7cf48a49fdef84705c7d310199c8.png" alt="r = 0.97"/>、<img class="math" src="../_images/math/7be930736ec2e547a7c87b0d22acf1e99466fd86.png" alt="\Delta x_{0} = 10^{-4}"/> 、nplot=30としたときの<img class="math" src="../_images/math/f0b11976371ba03717737b45b84dae866c2a10e7.png" alt="x_{0} - \lambda"/>グラフ</p>
</div>
<div class="align-center figure" id="fig-6-9-f7">
<a class="reference internal image-reference" href="../_images/figure_101.png"><img alt="r = 0.97 、Δx0 = 10^{-6} 、nplot=30としたときの x0-λ グラフ" src="../_images/figure_101.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/415352a3e94b7cf48a49fdef84705c7d310199c8.png" alt="r = 0.97"/>、<img class="math" src="../_images/math/3cbde63fe9cac6091b6294b92bf529f2260d3aa8.png" alt="\Delta x_{0} = 10^{-6}"/> 、nplot=30としたときの<img class="math" src="../_images/math/f0b11976371ba03717737b45b84dae866c2a10e7.png" alt="x_{0} - \lambda"/>グラフ</p>
</div>
<div class="align-center figure" id="fig-6-9-f8">
<a class="reference internal image-reference" href="../_images/figure_112.png"><img alt="r = 0.97 、Δx0 = 10^{-8} 、nplot=40としたときの x0-λ グラフ" src="../_images/figure_112.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/415352a3e94b7cf48a49fdef84705c7d310199c8.png" alt="r = 0.97"/>、<img class="math" src="../_images/math/5de5418065f18dbb304ece6a1fdc5c446b350e13.png" alt="\Delta x_{0} = 10^{-8}"/> 、nplot=40としたときの<img class="math" src="../_images/math/f0b11976371ba03717737b45b84dae866c2a10e7.png" alt="x_{0} - \lambda"/>グラフ</p>
</div>
<ol class="loweralpha simple" start="2">
<li>本文で述べたアルゴリズムを用いて、<img class="math" src="../_images/math/06e6b70c163ceb56b487b0fc40de07f36aa725dd.png" alt="\Delta r = 0.01"/>の刻み幅で、<img class="math" src="../_images/math/178cfa701fd2aa469cd1b21352c92b6ec874420e.png" alt="r=0.76"/>から<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>の範囲について、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を計算せよ。系がカオス的でないとき、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の符号はどうなるか。<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>に対してプロットし、問題6.2で得られた分岐図と対応させながら、得られた結果を説明せよ。得られた<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の結果を教科書に示されている図6.9と比較せよ。<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の符号は分岐図に見られる系の振る舞いとどのような関係があるか。<img class="math" src="../_images/math/ea6be111cc2aae3159b9e80692809a128b8e51da.png" alt="\lambda&lt;0"/>の場合には、2つの軌跡は一致し系はカオス的でなくなる。しかし<img class="math" src="../_images/math/6d845998dc1ed86a8894d0ceab5bbd9f60c63c78.png" alt="\lambda=0"/>では、軌跡はべき<img class="math" src="../_images/math/413f8a8e40062a9090d9d50b88bc7b551b314c26.png" alt="n"/>で代数的に離れていく。<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>のどの値に対して<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>は最大になるか。</li>
</ol>
<p>先に示したアルゴリズムを用いて、<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>のとき<img class="math" src="../_images/math/06e6b70c163ceb56b487b0fc40de07f36aa725dd.png" alt="\Delta r = 0.01"/>の刻み幅で、<img class="math" src="../_images/math/178cfa701fd2aa469cd1b21352c92b6ec874420e.png" alt="r=0.76"/>から<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>の範囲について、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>を計算し、その結果を横軸<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>、縦軸<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>のグラフにプロットした。これを<a class="reference internal" href="#fig-6-9-f9"><em>図9</em></a>に示す。また、さらに<img class="math" src="../_images/math/0a75a9155a66707d63d71c26121afa835d201165.png" alt="\Delta r"/>を小さくして$<img class="math" src="../_images/math/c3a0254f1791c105e9a78fd118cf1e21af0fd569.png" alt="\Delta r = 0.0001"/>としたものと、問題6.2でロジスティック写像について得られた<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>に関する分岐図(<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>)とを比較したものを<a class="reference internal" href="#fig-6-9-f10"><em>図10</em></a>に示す。この図から明らかなように、<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>が負のところでは系はカオス的でなく、窓を形成するような<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の値においても<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値は負の値である。また、図の中で点線で示したように、<img class="math" src="../_images/math/6d845998dc1ed86a8894d0ceab5bbd9f60c63c78.png" alt="\lambda=0"/>のときは、ちょうど系の挙動の分岐点にあたることが見て取れる。はじめの<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の定義からも分かるように、この値が負であるということは、初期値がずれていても、十分時間の経過した後には二つの値の間の差はほとんど0に等しくなることを意味し、則ち系の安定性を示している。分岐図だけでは、どの程度の安定性があるかまではわからないが、2つの図を並べて比較すると、<img class="math" src="../_images/math/ca432295ab929a54b51311bedc13033192740a59.png" alt="r=0.81"/>と<img class="math" src="../_images/math/a70e2d540818ac4be720e565163a608de5a6a7ff.png" alt="r=0.85"/>では、<img class="math" src="../_images/math/ca432295ab929a54b51311bedc13033192740a59.png" alt="r=0.81"/>の方が系はより安定であることを知ることができる。逆に、<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値が正であるところでは、<a class="reference internal" href="#fig-6-9-f10"><em>図10</em></a>の分岐図ではカオス的挙動を示していて、<img class="math" src="../_images/math/caca2e636f65608f88d9fa1fcfb902e29fbe458f.png" alt="r=1.0"/>のときに<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の値が最大となっている。これも先に述べた<img class="math" src="../_images/math/1ab0134b6e0837594649c75a2ed83cfd85a2d03d.png" alt="\lambda"/>の意味と確かに一致している。これらのことから、系のカオスの度合いを特徴づける指標としてリアプノフ指数が適当であることが理解できる。</p>
<div class="align-center figure" id="fig-6-9-f9">
<a class="reference internal image-reference" href="../_images/figure_33.png"><img alt="Δr = 0.01 、ntransient = 1000、n_calc = 100000、x0 = 0.5 、r-λ グラフ" src="../_images/figure_33.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/06e6b70c163ceb56b487b0fc40de07f36aa725dd.png" alt="\Delta r = 0.01"/>、ntransient = 1000、n_calc = 100000、<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>としたときの<img class="math" src="../_images/math/0ab1561951e71916b287741aa2824ee7da8c6574.png" alt="r - \lambda"/>グラフ</p>
</div>
<div class="align-center figure" id="fig-6-9-f10">
<a class="reference internal image-reference" href="../_images/figure_132.png"><img alt="r の値に対するリアプノフ指数と系の分岐図の比較" src="../_images/figure_132.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の値に対するリアプノフ指数と系の分岐図の比較</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>ロジスティック写像のリアプノフ指数を、素朴な方法で、またアルゴリズムを用いて計算することで、系のカオス的であることを表す指標としてのリアプノフ指数について理解を深めることができた。素朴な方法で求める際に、線形近似の適用範囲をどのようにして決めるかという問題に対して有効な方法を見いだせなかったが、そもそも精度よくリアプノフ指数を求めるには違ったアプローチをする必要があるということの理解の助けともなった。問題に対して、素朴な方法で解決するのが難しいと思われる場合、解析的に変形ができないか考えることの重要性を再認識できた。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題6.9 - ロジスティック写像のリアプノフ指数</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../6-8_other_example/6-8.html"
                        title="前の章へ">問題6.8 - 他の1次元写像</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../6-12_henon/6-12.html"
                        title="次の章へ">問題6.12 - エノン写像</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-9_lyapunov/6-9.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../6-12_henon/6-12.html" title="問題6.12 - エノン写像"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../6-8_other_example/6-8.html" title="問題6.8 - 他の1次元写像"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>